
#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glaux.lib")

#include "main.h"
#include <math.h>
#include "Camera.h"


// Include Your Header File Here 
// Then Call Function CreateMaterialLib()
//			Don't forget Create<YourObj/s>()
//			in RenderScene() Call glCallList Function to Call your Objects ObjectID

#define		INC	3.0
#define		R_180	3.142857142
#define		R_90	1.571428571

bool  g_bFullScreen = 1;							// Set full screen as default
HWND  g_hWnd;											// This is the handle for the window
RECT  g_rRect;											// This holds the window dimensions
HDC   g_hDC;											// General HDC - (handle to device context)
HGLRC g_hRC;											// General OpenGL_DC - Our Rendering Context for OpenGL
HINSTANCE g_hInstance;									// This holds the global hInstance for UnregisterClass() in DeInit()
float rotationH,rotationV;
Point3 CamPos, CamTar;
float thetha,thethaV=0;
float focullength=2;
float step=5;

GLfloat Vertex[] = {	-75.0000,	-50.0000,	0.0000,
						75.0000,	-50.0000,	0.0000,
						-75.0000,	50.0000,	0.0000,
						75.0000,	50.0000,	0.0000
					};

GLfloat TVertex[] = {	0.0f, 0.0f, 
						1.0f, 0.0f, 
						0.0f, 1.0f, 
						1.0f, 1.0f, 
					};
CCamera	g_Camera;

UINT g_Texture[MAX_TEXTURES];


void Init(HWND hWnd)
{
	g_hWnd = hWnd;										// Assign the window handle to a global window handle
	GetClientRect(g_hWnd, &g_rRect);					// Assign the windows rectangle to a global RECT
	InitializeOpenGL(g_rRect.right, g_rRect.bottom);	// Init OpenGL with the global rect

	// CreateMaterialLib() here and 
	// Object's Create Functions 


	g_Camera.PositionCamera( 10,150,12, 9,150,12, 0,1,0 );
	g_Camera.SetCameraRadius(1);

}


WPARAM MainLoop()
{
	MSG msg;
	while(1)											// Do our infinate loop
	{													// Check if there was a message
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
        { 
			if(msg.message == WM_QUIT)					// If the message wasnt to quit
				break;
            TranslateMessage(&msg);						// Find out what the message does
            DispatchMessage(&msg);						// Execute the message
        }
		else											// if there wasn't a message
		{ 
			g_Camera.Update();
			RenderScene();								// Redraw the scene every frame
		}	 
	}

	DeInit();											// Free all the app's memory allocated

	return(msg.wParam);									// Return from the program
}


void RenderScene() 
{
	CamTar.x = CamPos.x+focullength*cos( thetha );
	CamTar.z = CamPos.z+focullength*sin( thetha );
	CamPos.y = 100;
	CamTar.y = 100;

	glVertexPointer( 3, GL_FLOAT, 0, Vertex );
	glTexCoordPointer(2, GL_FLOAT, 0, TVertex );

	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	g_Camera.Look();
	glPushMatrix();

			// Call Your Object Lists Here by 
			// glCallList()
			// Like glCallList( BOX01 ) if BOX01 is defined.
		
	glPopMatrix();
	
	SwapBuffers(g_hDC);									// Swap the backbuffers to the foreground
}



LRESULT CALLBACK WinProc(HWND hWnd,UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    LONG    lRet = 0; 
    PAINTSTRUCT    ps;
    static int lxPos,lyPos;
    static int xPos, yPos;
	

    POINT mpos;
    switch (uMsg)
	{ 
    case WM_SIZE:										// If the window is resized
		if(!g_bFullScreen)								// Do this only if we are NOT in full screen
		{
			SizeOpenGLScreen(LOWORD(lParam),HIWORD(lParam));// LoWord=Width, HiWord=Height
			GetClientRect(hWnd, &g_rRect);	
						
		}
        break; 
		
	case WM_PAINT:										// If we need to repaint the scene
		BeginPaint(hWnd, &ps);							// Init the paint struct		
		EndPaint(hWnd, &ps);							// EndPaint, Clean up
		break;
    case WM_CLOSE:										// If the window is being closes
        PostQuitMessage(0);								// Send a QUIT Message to the window
        break; 
     
    default:											// Return by default
        lRet = DefWindowProc (hWnd, uMsg, wParam, lParam); 
        break; 
    } 
 
    return lRet;										// Return by default
}
